﻿define("epi-ecf-ui/component/CatalogNavigationTree", [
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Deferred",
    "dojo/when",
// epi
    "epi-cms/component/ContentNavigationTree",
// commerce
    "../widget/viewmodel/CatalogTreeStoreModel",
    "./ContentContextMenuCommandProvider"
],

function (
// dojo
    declare,
    lang,
    Deferred,
    when,
// epi
    ContentNavigationTree,
// commerce
    CatalogTreeStoreModel,
    ContextMenuCommandProvider
 ) {

    // module:
    //      epi-ecf-ui.component.CatalogNavigationTree

    return declare([ContentNavigationTree], {
        // summary:
        //      Catalog tree component, which support market filtering.
        // tags:
        //      public

        contextMenuCommandProvider: ContextMenuCommandProvider,

        _createTreeModel: function () {
            // summary:
            //      Create content tree model
            // tags:
            //      protected override

            return new CatalogTreeStoreModel({
                root: this.root,
                typeIdentifiers: this.typeIdentifiers,
                containedTypes: this.settings.containedTypes
            });
        },

        selectContent: function (contentReferenceAsString, setFocus, needParentRefresh, onComplete) {
            // summary:
            //      Select a given content.
            // tags:
            //      public override

            var args = arguments,
                inherited = this.getInherited(args),
                deferred = new Deferred();

            return when(this.model.store.get(contentReferenceAsString), lang.hitch(this, function (content) {
                if (content && !content.properties.isLinkedToCurrentCategory) {
                    return inherited.apply(this, args);
                }

                return deferred.promise;
            }));
        }
    });

});